Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/SampleSizeDetermination.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/SampleSizeDetermination.cs	(revision 9328)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/SampleSizeDetermination.cs	(revision 9329)
@@ -49,9 +49,9 @@
     /// <returns>Cohen's d. 
     /// d = 0.2 means small effect
-    /// d = 0.5 means average effect
+    /// d = 0.5 means medium effect
     /// d = 0.8 means big effect
     /// According to Wikipedia this means: "A lower Cohen's d indicates a necessity of larger sample sizes, and vice versa."
     /// </returns>
-    public static double CohensD(double[] d1, double[] d2) {
+    public static double CalculateCohensD(double[] d1, double[] d2) {
       double x1, x2, s1, s2;
 
@@ -65,8 +65,9 @@
 
     /// <summary>
-    /// Calculates Hedges' g.
+    /// Calculates Hedges' g. 
+    /// Hedges' g works like Cohen's d but corrects for bias. 
     /// </summary>
     /// <returns>Hedges' g</returns>
-    public static double HedgesG(double[] d1, double[] d2) {
+    public static double CalculateHedgesG(double[] d1, double[] d2) {
       double x1, x2, s1, s2, n1, n2, s, g, c;
 
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.cs	(revision 9328)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.cs	(revision 9329)
@@ -26,4 +26,5 @@
 using System.Windows.Forms;
 using HeuristicLab.Analysis.AlgorithmBehavior.Analyzers;
+using HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views;
 using HeuristicLab.Core.Views;
 using HeuristicLab.Data;
@@ -206,5 +207,5 @@
       DoubleMatrix pValsMatrix = new DoubleMatrix(1, stringConvertibleMatrixView.Content.Columns);
       pValsMatrix.ColumnNames = stringConvertibleMatrixView.Content.ColumnNames;
-      pValsMatrix.RowNames = new string[] { "p-Values" };
+      pValsMatrix.RowNames = new string[] { "p-Value" };
 
       double val;
@@ -232,7 +233,7 @@
       }
 
-      DoubleMatrix pValsMatrix = new DoubleMatrix(1, stringConvertibleMatrixView.Content.Columns);
+      DoubleMatrix pValsMatrix = new DoubleMatrix(3, stringConvertibleMatrixView.Content.Columns);
       pValsMatrix.ColumnNames = stringConvertibleMatrixView.Content.ColumnNames;
-      pValsMatrix.RowNames = new string[] { "p-Values" };
+      pValsMatrix.RowNames = new string[] { "p-Value", "Cohen's d", "Hedges' g" };
 
       double bothtails;
@@ -242,4 +243,6 @@
         alglib.mannwhitneyutest(data[colIndex], data[colIndex].Length, data[i], data[i].Length, out bothtails, out lefttail, out righttail);
         pValsMatrix[0, i] = bothtails;
+        pValsMatrix[1, i] = SampleSizeDetermination.CalculateCohensD(data[colIndex], data[i]);
+        pValsMatrix[2, i] = SampleSizeDetermination.CalculateHedgesG(data[colIndex], data[i]);
       }
 
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.resx
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.resx	(revision 9328)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.resx	(revision 9329)
@@ -166,5 +166,5 @@
         lR7X/aj3Y+uI5ciZUdfRvidBTx6Mscae/5T+04fx/Kfkp+UTqhONk2aTp6fcp24+W/1s/Hnq8/npgp+l
         f65+ofviu18cf+mbWTUz/pL/cuHX4lfyr468Xva6e9Z/9vGb5Dfzc4Vv5d8efcd41/s+7P3EfOYH7IeK
-        j3ofuz55f3q4kLyw8Bv3hPP74uYdwgAAAAlwSFlzAAALDwAACw8BkvkDpQAAABl0RVh0U29mdHdhcmUA
+        j3ofuz55f3q4kLyw8Bv3hPP74uYdwgAAAAlwSFlzAAALDgAACw4BQL7hQQAAABl0RVh0U29mdHdhcmUA
         UGFpbnQuTkVUIHYzLjUuODc7gF0AAAK0SURBVDhPrZBrSNNRAMWNvkVEEBT0oY+BUAgSRBhIQmUqKYb4
         KgudU1MTlj2WZUlMykdu+VhatmWKWaaITF35qCmzWoaGj81kms72dm5/3cM9TtvdX9Sob/0+XC6Hcw73
@@ -194,5 +194,13 @@
 
 For pairwise comparision of the groups the Mann-Whitney U test is used. 
-It also requires sample sizes of at least 5 samples.</value>
+It also requires sample sizes of at least 5 samples.
+
+The p-values calculated by the statistical tests are interpreted as follows:
+The null hypothesis states that the groups which are compared have the same distribution.
+A p-value &lt; 0.05 (this value is often chosen as significance level)  means the null hypothesis is rejected, 
+which therefore means that the distributions are not equal. 
+
+For the pariwise statistical test, in addition to the p-value, Cohen's d and Hedges' g are calculated.
+According to Wikipedia, these values can be interpreted as follows: "A lower Cohen's d indicates a necessity of larger sample sizes, and vice versa."</value>
   </data>
 </root>