Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/RunCollectionStatisticalTabularView.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/RunCollectionStatisticalTabularView.cs	(revision 9332)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/RunCollectionStatisticalTabularView.cs	(revision 9333)
@@ -133,6 +133,8 @@
         this.Invoke(new EventHandler(run_Changed), sender, e);
       else {
-        IRun run = (IRun)sender;
-        UpdateRun(run);
+        if (!Content.UpdateOfRunsInProgress) {
+          IRun run = (IRun)sender;
+          UpdateRun(run);
+        }
       }
     }
@@ -262,4 +264,5 @@
       StringMatrix sm = (StringMatrix)stringConvertibleMatrixView.Content;
 
+      Content.UpdateOfRunsInProgress = true;
       for (int i = 0; i < runs.Count(); i++) {
         IRun run = runs.ElementAt(i);
@@ -271,4 +274,5 @@
         }
       }
+      Content.UpdateOfRunsInProgress = false;
       //update column names of run collection
       Content.Modify();
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/SampleSizeDetermination.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/SampleSizeDetermination.cs	(revision 9332)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/SampleSizeDetermination.cs	(revision 9333)
@@ -30,8 +30,8 @@
     /// </summary>
     /// <param name="samples">The pilot sample.</param>
-    /// <param name="e">Precision. Default precision is 1%. </param>
+    /// <param name="e">Precision. </param>
     /// <param name="conf">Confidence Interval.</param>
     /// <returns>Number of required samples for the given confidence interval and precision. </returns>
-    public static int DetermineSampleSizeByEstimatingMean(double[] samples, double e = 0.01, double conf = 0.95) {
+    public static int DetermineSampleSizeByEstimatingMean(double[] samples, double e, double conf = 0.95) {
       if (e < 0) throw new ArgumentException("e needs to be a positive number.");
       if (conf < 0 || conf > 1) throw new ArgumentException("The confidence Interval must be between zero and one.");
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.cs	(revision 9332)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.cs	(revision 9333)
@@ -31,4 +31,5 @@
 using HeuristicLab.MainForm;
 using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Views;
 
 namespace HeuristicLab.Analysis.AlgorithmBehavior.Views {
@@ -255,4 +256,13 @@
       }
     }
+
+    private void openBoxPlotToolStripMenuItem_Click(object sender, EventArgs e) {
+      RunCollectionBoxPlotView boxplotView = new RunCollectionBoxPlotView();
+      boxplotView.Content = Content;
+      // TODO: enable as soon as we move to HeuristicLab.Optimization.Views
+      // boxplotView.xAxisComboBox.SelectedItem = xAxisComboBox.SelectedItem;
+      // boxplotView.yAxisComboBox.SelectedItem = yAxisComboBox.SelectedItem;
+      boxplotView.Show();
+    }
   }
 }
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.designer.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.designer.cs	(revision 9332)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.designer.cs	(revision 9333)
@@ -48,4 +48,6 @@
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(StatisticalTestingView));
       this.stringConvertibleMatrixView = new HeuristicLab.Data.Views.StringConvertibleMatrixView();
+      this.contextMenuStrip1 = new System.Windows.Forms.ContextMenuStrip(this.components);
+      this.openBoxPlotToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.groupByLabel = new System.Windows.Forms.Label();
       this.label1 = new System.Windows.Forms.Label();
@@ -62,4 +64,5 @@
       this.splitContainer1 = new System.Windows.Forms.SplitContainer();
       this.splitContainer2 = new System.Windows.Forms.SplitContainer();
+      this.contextMenuStrip1.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer1)).BeginInit();
       this.splitContainer1.Panel1.SuspendLayout();
@@ -79,4 +82,5 @@
       this.stringConvertibleMatrixView.Caption = "StringConvertibleMatrix View";
       this.stringConvertibleMatrixView.Content = null;
+      this.stringConvertibleMatrixView.ContextMenuStrip = this.contextMenuStrip1;
       this.stringConvertibleMatrixView.Location = new System.Drawing.Point(3, 38);
       this.stringConvertibleMatrixView.Name = "stringConvertibleMatrixView";
@@ -87,4 +91,18 @@
       this.stringConvertibleMatrixView.TabIndex = 0;
       // 
+      // contextMenuStrip1
+      // 
+      this.contextMenuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.openBoxPlotToolStripMenuItem});
+      this.contextMenuStrip1.Name = "contextMenuStrip1";
+      this.contextMenuStrip1.Size = new System.Drawing.Size(175, 26);
+      // 
+      // openBoxPlotToolStripMenuItem
+      // 
+      this.openBoxPlotToolStripMenuItem.Name = "openBoxPlotToolStripMenuItem";
+      this.openBoxPlotToolStripMenuItem.Size = new System.Drawing.Size(174, 22);
+      this.openBoxPlotToolStripMenuItem.Text = "Open BoxPlot View";
+      this.openBoxPlotToolStripMenuItem.Click += new System.EventHandler(this.openBoxPlotToolStripMenuItem_Click);
+      // 
       // groupByLabel
       // 
@@ -119,5 +137,6 @@
       // testButton
       // 
-      this.testButton.Location = new System.Drawing.Point(142, 3);
+      this.testButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.testButton.Location = new System.Drawing.Point(196, 3);
       this.testButton.Name = "testButton";
       this.testButton.Size = new System.Drawing.Size(109, 23);
@@ -153,4 +172,5 @@
       this.pValTextBox.Location = new System.Drawing.Point(363, 5);
       this.pValTextBox.Name = "pValTextBox";
+      this.pValTextBox.ReadOnly = true;
       this.pValTextBox.Size = new System.Drawing.Size(144, 20);
       this.pValTextBox.TabIndex = 13;
@@ -180,5 +200,6 @@
       // pairwiseTestButton
       // 
-      this.pairwiseTestButton.Location = new System.Drawing.Point(4, 3);
+      this.pairwiseTestButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.pairwiseTestButton.Location = new System.Drawing.Point(58, 3);
       this.pairwiseTestButton.Name = "pairwiseTestButton";
       this.pairwiseTestButton.Size = new System.Drawing.Size(132, 23);
@@ -249,4 +270,5 @@
       this.Name = "StatisticalTestingView";
       this.Size = new System.Drawing.Size(924, 500);
+      this.contextMenuStrip1.ResumeLayout(false);
       this.splitContainer1.Panel1.ResumeLayout(false);
       this.splitContainer1.Panel1.PerformLayout();
@@ -280,4 +302,6 @@
     private System.Windows.Forms.SplitContainer splitContainer1;
     private System.Windows.Forms.SplitContainer splitContainer2;
+    private System.Windows.Forms.ContextMenuStrip contextMenuStrip1;
+    private System.Windows.Forms.ToolStripMenuItem openBoxPlotToolStripMenuItem;
   }
 }
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.resx
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.resx	(revision 9332)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views/3.3/StatisticalTestingView.resx	(revision 9333)
@@ -118,4 +118,7 @@
     <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
+  <metadata name="contextMenuStrip1.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>114, 17</value>
+  </metadata>
   <assembly alias="System.Drawing" name="System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
   <data name="infoLabel.Image" type="System.Drawing.Bitmap, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
@@ -166,5 +169,5 @@
         lR7X/aj3Y+uI5ciZUdfRvidBTx6Mscae/5T+04fx/Kfkp+UTqhONk2aTp6fcp24+W/1s/Hnq8/npgp+l
         f65+ofviu18cf+mbWTUz/pL/cuHX4lfyr468Xva6e9Z/9vGb5Dfzc4Vv5d8efcd41/s+7P3EfOYH7IeK
-        j3ofuz55f3q4kLyw8Bv3hPP74uYdwgAAAAlwSFlzAAALDgAACw4BQL7hQQAAABl0RVh0U29mdHdhcmUA
+        j3ofuz55f3q4kLyw8Bv3hPP74uYdwgAAAAlwSFlzAAALDAAACwwBP0AiyAAAABl0RVh0U29mdHdhcmUA
         UGFpbnQuTkVUIHYzLjUuODc7gF0AAAK0SURBVDhPrZBrSNNRAMWNvkVEEBT0oY+BUAgSRBhIQmUqKYb4
         KgudU1MTlj2WZUlMykdu+VhatmWKWaaITF35qCmzWoaGj81kms72dm5/3cM9TtvdX9Sob/0+XC6Hcw73