Index: /trunk/sources/HeuristicLab.Algorithms.Benchmarks/3.3/BenchmarkAlgorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.Benchmarks/3.3/BenchmarkAlgorithm.cs	(revision 9342)
+++ /trunk/sources/HeuristicLab.Algorithms.Benchmarks/3.3/BenchmarkAlgorithm.cs	(revision 9343)
@@ -327,5 +327,5 @@
     private void Run(object state) {
       CancellationToken cancellationToken = (CancellationToken)state;
-      lastUpdateTime = DateTime.Now;
+      lastUpdateTime = DateTime.UtcNow;
       System.Timers.Timer timer = new System.Timers.Timer(250);
       timer.AutoReset = true;
@@ -352,5 +352,5 @@
         timer.Elapsed -= new System.Timers.ElapsedEventHandler(timer_Elapsed);
         timer.Stop();
-        ExecutionTime += DateTime.Now - lastUpdateTime;
+        ExecutionTime += DateTime.UtcNow - lastUpdateTime;
       }
     }
@@ -359,5 +359,5 @@
       System.Timers.Timer timer = (System.Timers.Timer)sender;
       timer.Enabled = false;
-      DateTime now = DateTime.Now;
+      DateTime now = DateTime.UtcNow;
       ExecutionTime += now - lastUpdateTime;
       lastUpdateTime = now;
Index: /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/FixedDataAnalysisAlgorithm.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/FixedDataAnalysisAlgorithm.cs	(revision 9342)
+++ /trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/FixedDataAnalysisAlgorithm.cs	(revision 9343)
@@ -96,5 +96,5 @@
     private void Run(object state) {
       CancellationToken cancellationToken = (CancellationToken)state;
-      lastUpdateTime = DateTime.Now;
+      lastUpdateTime = DateTime.UtcNow;
       System.Timers.Timer timer = new System.Timers.Timer(250);
       timer.AutoReset = true;
@@ -107,5 +107,5 @@
         timer.Elapsed -= new System.Timers.ElapsedEventHandler(timer_Elapsed);
         timer.Stop();
-        ExecutionTime += DateTime.Now - lastUpdateTime;
+        ExecutionTime += DateTime.UtcNow - lastUpdateTime;
       }
 
@@ -121,5 +121,5 @@
       System.Timers.Timer timer = (System.Timers.Timer)sender;
       timer.Enabled = false;
-      DateTime now = DateTime.Now;
+      DateTime now = DateTime.UtcNow;
       ExecutionTime += now - lastUpdateTime;
       lastUpdateTime = now;
Index: /trunk/sources/HeuristicLab.Core/3.3/Engine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 9342)
+++ /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 9343)
@@ -145,5 +145,5 @@
 
       OnStarted();
-      lastUpdateTime = DateTime.Now;
+      lastUpdateTime = DateTime.UtcNow;
       System.Timers.Timer timer = new System.Timers.Timer(250);
       timer.AutoReset = true;
@@ -156,5 +156,5 @@
         timer.Elapsed -= new System.Timers.ElapsedEventHandler(timer_Elapsed);
         timer.Stop();
-        ExecutionTime += DateTime.Now - lastUpdateTime;
+        ExecutionTime += DateTime.UtcNow - lastUpdateTime;
       }
 
@@ -166,5 +166,5 @@
       System.Timers.Timer timer = (System.Timers.Timer)sender;
       timer.Enabled = false;
-      DateTime now = DateTime.Now;
+      DateTime now = DateTime.UtcNow;
       ExecutionTime += now - lastUpdateTime;
       lastUpdateTime = now;
Index: /trunk/sources/HeuristicLab.DebugEngine/3.3/DebugEngine.cs
===================================================================
--- /trunk/sources/HeuristicLab.DebugEngine/3.3/DebugEngine.cs	(revision 9342)
+++ /trunk/sources/HeuristicLab.DebugEngine/3.3/DebugEngine.cs	(revision 9343)
@@ -155,5 +155,5 @@
       cancellationTokenSource = new CancellationTokenSource();
       stopPending = false;
-      lastUpdateTime = DateTime.Now;
+      lastUpdateTime = DateTime.UtcNow;
       timer.Start();
       try {
@@ -166,5 +166,5 @@
       }
       timer.Stop();
-      ExecutionTime += DateTime.Now - lastUpdateTime;
+      ExecutionTime += DateTime.UtcNow - lastUpdateTime;
       cancellationTokenSource.Dispose();
       cancellationTokenSource = null;
@@ -242,5 +242,5 @@
 
       OnStarted();
-      lastUpdateTime = DateTime.Now;
+      lastUpdateTime = DateTime.UtcNow;
       timer.Start();
       try {
@@ -253,5 +253,5 @@
       finally {
         timer.Stop();
-        ExecutionTime += DateTime.Now - lastUpdateTime;
+        ExecutionTime += DateTime.UtcNow - lastUpdateTime;
 
         if (IsAtBreakpoint)
@@ -263,5 +263,5 @@
       System.Timers.Timer timer = (System.Timers.Timer)sender;
       timer.Enabled = false;
-      DateTime now = DateTime.Now;
+      DateTime now = DateTime.UtcNow;
       ExecutionTime += now - lastUpdateTime;
       lastUpdateTime = now;